/* 
 * Midway Distributed Shared Memory System
 * Copyright (c) 1994 Carnegie Mellon University
 * All Rights Reserved.
 * 
 * Permission to use, copy, modify and distribute this software and its
 * documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 * 
 * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND FOR
 * ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 */
/*
 * add print routines 26jul93 mjz
 * update for new nw.h 12dec93, mjz
 */
#include <nw.h>

char *nw_result_char( nw_result xxx )
{
  char *result;

  switch(xxx) {
  case NW_SUCCESS:		result = "NW_SUCCESS";			break;
  case NW_FAILURE:		result = "NW_FAILURE";			break;
  case NW_NO_VC:		result = "NW_NO_VC";			break;
  case NW_NO_RESOURCES:		result = "NW_NO_RESOURCES";		break;
  case NW_BAD_ADDRESS:		result = "NW_BAD_ADDRESS";		break;
  case NW_OVERRUN:		result = "NW_OVERRUN";			break;
  case NW_NO_CARRIER:		result = "NW_NO_CARRIER";		break;
  case NW_NOT_SERVER:		result = "NW_NOT_SERVER";		break;
  case NW_NO_EP:		result = "NW_NO_EP";			break;
  case NW_BAD_EP:		result = "NW_BAD_EP";			break;
  case NW_INVALID_ARGUMENT:	result = "NW_INVALID_ARGUMENT";		break;
  case NW_PROT_VIOLATION:	result = "NW_PROT_VIOLATION";		break;
  case NW_BAD_BUFFER:		result = "NW_BAD_BUFFER";		break;
  case NW_BAD_LENGTH:		result = "NW_BAD_LENGTH";		break;
  case NW_NO_REMOTE_EP:		result = "NW_NO_REMOTE_EP";		break;
  case NW_TIMEOUT:		result = "NW_TIMEOUT";			break;
  case NW_TRANSIENT_STATE:	result = "NW_TRANSIENT_STATE";		break;
  case NW_INCONSISTENCY:	result = "NW_INCONSISTENCY";		break;
  case NW_SYNCH:		result = "NW_SYNCH";			break;
  case NW_QUEUED:		result = "NW_QUEUED";			break;
  case NW_ALREADY_CONNECTED:	result = "NW_ALREADY_CONNECTED";	break;
  case NW_NOT_CONNECTABLE:	result = "NW_NOT_CONNECTABLE";		break;
  case NW_NOT_CONNECTED:	result = "NW_NOT_CONNECTED";		break;
  case NW_NOT_MULTI:		result = "NW_NOT_MULTI";		break;
  case NW_BAD_PEER:		result = "NW_BAD_PEER";			break;
  case NW_NO_DELIVERY:		result = "NW_NO_DELIVERY";		break;
  case NW_ABORTED:		result = "NW_ABORTED";			break;
  case NW_ABORT:		result = "NW_ABORT";			break;
  case NW_UNDELIVERED_ABORT:	result = "NW_UNDELIVERED_ABORT";	break;
  default: 			result = "*** Unknown NW result! ***";	break;
  }
  return(result);
} /*nw_result_char*/

char *nw_state_char( nw_state xxx )
{
  char *result;

  switch(xxx) {
  case NW_INEXISTENT:		result = "NW_INEXISTENT";		break;
  case NW_UNCONNECTED:		result = "NW_UNCONNECTED";		break;
  case NW_ORIGINATING:		result = "NW_ORIGINATING";		break;
  case NW_REDIRECTING:		result = "NW_REDIRECTING";		break;
  case NW_SIMPLEX_ORIGINATED:	result = "NW_SIMPLEX_ORIGINATED";	break;
  case NW_DUPLEX_ORIGINATING:	result = "NW_DUPLEX_ORIGINATING";	break;
  case NW_DUPLEX_ORIGINATED:	result = "NW_DUPLEX_ORIGINATED";	break;
  case NW_SPAWNING:		result = "NW_SPAWNING";			break;
  case NW_SPAWNED:		result = "NW_SPAWNED";			break;
  case NW_SPAWNED_ACCEPTING:	result = "NW_SPAWNED_ACCEPTING";	break;
  case NW_SIMPLEX_ACCEPTED:	result = "NW_SIMPLEX_ACCEPTED";		break;
  case NW_DUPLEX_ACCEPTING:	result = "NW_DUPLEX_ACCEPTING";		break;
  case NW_DUPLEX_ACCEPTED:	result = "NW_DUPLEX_ACCEPTED";		break;
  case NW_ORIGINATOR_RCLOSING:	result = "NW_ORIGINATOR_RCLOSING";	break;
  case NW_ORIGINATOR_CLOSING:	result = "NW_ORIGINATOR_CLOSING";	break;
  case NW_ACCEPTOR_CLOSING:	result = "NW_ACCEPTOR_CLOSING";		break;
  case NW_ACCEPTOR_RCLOSING:	result = "NW_ACCEPTOR_RCLOSING";	break;
  case NW_INEXISTENT_DISMANTLING: result = "NW_INEXISTENT_DISMANTLING";	break;
  case NW_UNCONNECTED_DISMANTLING: result = "NW_UNCONNECTED_DISMANTLING";break;
  case NW_SIMPLEX_DISMANTLING:	result = "NW_SIMPLEX_DISMANTLING";	break;
  case NW_DUPLEX_DISMANTLING:	result = "NW_DUPLEX_DISMANTLING";	break;
  case NW_OPEN_EXAMINING:	result = "NW_OPEN_EXAMINING";		break;
  case NW_MULTI_EXAMINING:	result = "NW_MULTI_EXAMINING";		break;
  case NW_ADD_EXAMINING:	result = "NW_ADD_EXAMINING";		break;
  case NW_MULTI_ORIGINATING:	result = "NW_MULTI_ORIGINATING";	break;
  case NW_MULTI_ORIGINATED:	result = "NW_MULTI_ORIGINATED";		break;
  case NW_MULTI_CLOSING:	result = "NW_MULTI_CLOSING";		break;
  case NW_MULTI_CLOSING_ALL:	result = "NW_MULTI_CLOSING_ALL";	break;
  case NW_MULTI_ACCEPTED:	result = "NW_MULTI_ACCEPTED";		break;
  case NW_MULTI_RCLOSING:	result = "NW_MULTI_RCLOSING";		break;
  default:			result = "*** Unknown NW state! ***";	break;
  }
  return(result);
} /* nw_state_char */
