/* 
 * Midway Distributed Shared Memory System
 * Copyright (c) 1994 Carnegie Mellon University
 * All Rights Reserved.
 * 
 * Permission to use, copy, modify and distribute this software and its
 * documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 * 
 * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND FOR
 * ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 */
/*
 * linex.h: Routines for line exceptions when dirting cache lines.
 * 
 *
 * 25 Aug 92 (was): Initial code 
 *
 */
#ifndef __LINEX_H__
#define __LINEX_H__


#ifdef __LINEX_INTERNAL__

#undef EXTERN
#define EXTERN			/* routines are defined locally */

#else 

#undef EXTERN
#define EXTERN extern           /* routines are external */

#endif /* __LINEX_INTERNAL__ */




/*
 * Define prototypes for calling line exception routine
 */

EXTERN void 
mid_line_exception
  (
   vm_address_t  dataOffset,	/* offset in shared region being written */
   u_long        dataLen,	/* length being written */
   clock_t      *dbitP,		/* address of dbit to set */
   region_info   riP		/* ptr to region info for dataAddr */
   );


#endif /* __LINEX_H__ */
