/* 
 * Midway Distributed Shared Memory System
 * Copyright (c) 1994 Carnegie Mellon University
 * All Rights Reserved.
 * 
 * Permission to use, copy, modify and distribute this software and its
 * documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 * 
 * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND FOR
 * ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 */
/*
 * rsched.h: info for remote scheduling of threads... i.e. how to crank
 *	one up via the equivalent of a "create" command... (really a
 *	remote cthread_fork()
 *
 * 19 Jun 91 (mjz)
 */

/* one of these for every processor; shows waiting thread */
/* how about threadS??? */
typedef struct sched_info {
  u_long thread;		/* remote thread id that's waiting */
  u_long tid;			/* transaction id of the wait */
  u_long wakeuptime;		/* time it was last woken (for global lock) */
  u_long owakeupt;		/* saved (for retries) */
  void   (*proc)();		/* proc called (for retry) */
  u_long arg;			/* proc's arg (better be shared if ptr) */
} sched_info_t;
