/* 
 * Midway Distributed Shared Memory System
 * Copyright (c) 1994 Carnegie Mellon University
 * All Rights Reserved.
 * 
 * Permission to use, copy, modify and distribute this software and its
 * documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 * 
 * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND FOR
 * ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 */
/*
 * socket_iface.h: defn of fns in socket_iface.c, for type checking, etc.
 */

int midway_socket_rcv(char **buf, 
		      int *buflen, 
		      u_int *rcvtime,
		      struct sockaddr *sin
		      );

int midway_socket_sendto(
			 int s,
			 char *msg,
			 int len,
			 int flags,
			 struct sockaddr *to,
			 int tolen,
			 int dest
			 );

int midway_socket_sendmsg(
			  int s,
			  struct msghdr msg[],
			  int flags,
			  int dest
			  );
  
int midway_socket_wantreply(
			    comm_filter filt,
			    int cpti
			    );
