/* 
 * Midway Distributed Shared Memory System
 * Copyright (c) 1994 Carnegie Mellon University
 * All Rights Reserved.
 * 
 * Permission to use, copy, modify and distribute this software and its
 * documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 * 
 * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND FOR
 * ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 */
#include <mach.h>

typedef struct backing_page_data {
    char *data;
    vm_offset_t offset;
    struct backing_page_data *next;
} *backing_page_t;

typedef struct backing_store_data *backing_store_t;

backing_store_t backing_store_create();
void backing_store_release();


void backing_store_write();

backing_page_t backing_store_read_page();
void backing_store_release_page();


			   
