/* 
 * Midway Distributed Shared Memory System
 * Copyright (c) 1994 Carnegie Mellon University
 * All Rights Reserved.
 * 
 * Permission to use, copy, modify and distribute this software and its
 * documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 * 
 * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND FOR
 * ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 */
/*
 * Mach Operating System
 * Copyright (c) 1989 Carnegie-Mellon University and Alessandro Forin
 * All rights reserved.  The CMU software License Agreement specifies
 * the terms and conditions for use and redistribution.
 */
/*
 * HISTORY
 *  6-Oct-89  Alessandro Forin (af) at Carnegie-Mellon University
 *	Created.
 * $Log:$
 *  6 Aug 91 (mjz): call midway_main v. main...
 * 15 Aug 91 (mjz): only call midway_init_routine or main; no need for
 * 		midway_main here anymore...
 */
#include <varargs.h>

va_list environ;
unsigned errno;

int 	(*mach_init_routine)(),
	(*_cthread_init_routine)(),
	(*_cthread_exit_routine)();

int 	(*midway_init_routine)(),
	(*midway_exit_routine)();


__start( argp )
	register va_list argp;
{
	register unsigned argc;
	register va_list argv;

	argc = va_arg(argp, unsigned);
	argv = argp;
	environ = argv + (argc + 1 ) * sizeof(char*);

	if (mach_init_routine)
		(*mach_init_routine)();
	if (_cthread_init_routine) {
	    char *newsp;
	    newsp = (char*)(*_cthread_init_routine)();
	    if (newsp)  {
		/* the call to fixup_sp is culled out by the makefile */
		(void)fixup_sp(newsp - 0x14);	
	    }
	}

		

	/* midway init routine calls midway_main, which calls main() if
	   necessary. */
	if (midway_init_routine)
		argc = (*midway_init_routine)(argc, argv, environ);
	else
		argc = main(argc, argv, environ);

	if (_cthread_exit_routine)
		(*_cthread_exit_routine)(argc);

	if (midway_exit_routine)
		(*midway_exit_routine)(argc);

	exit(argc);
}

#ifdef	MCRT0
_exit(ret)
{
	/* Save profiling info in file */
	monitor(0);
	exit(ret);
}
#endif	MCRT0

eprol(){}
